]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- copy paste error fix
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 %__rm                   /bin/rm --interactive=never
12
13 # Build system path macros.
14 #
15 %__autoconf             autoconf %{?debug:-Wall}
16 %__automake             automake -a -c -f --foreign
17 %__autopoint            autopoint --force
18
19 %__gettextize { \
20         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
21                 gettextize --copy --force --no-changelog; \
22         else \
23                 gettextize --copy --force --no-changelog --intl; \
24         fi; \
25         if [ ! -f po/Makevars ]; then \
26                 cp -f po/Makevars{.template,}; \
27         fi; \
28 }
29
30 %__glib_gettextize      glib-gettextize --copy --force
31 %__gnome_doc_common     gnome-doc-common --copy
32 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
33 %__gtkdocize            gtkdocize --copy
34 %__intltoolize          intltoolize --copy --force
35 %__libtoolize           libtoolize --copy --force
36
37 #       Path to top of build area.
38 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
39
40 #       The number of cvs changelog entries kept when building package.
41 %_buildchangelogtruncate 20
42
43 %dependencytracking     %{nil}
44
45 #       Relations between package names that cause dependency loops
46 #       with legacy packages that cannot be fixed. Relations are
47 #       specified as
48 #               p>q
49 #       where package p has a Requires: on something that package q Provides:
50 #
51 # XXX   Note: that there cannot be any whitespace within the string "p>q",
52 #       and that both p and q are package names (i.e. no version/release).
53 %_dependency_whiteout   %{nil}
54
55 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
58
59 #-----------------------------------------------------------------
60 #
61 # (re)definition of %{rpm*flags} with %filterout_* support
62 # BuildRequires:        awk
63 # BuildRequires:        rpmbuild(macros) >= 1.315
64 #
65 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
66 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
67 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
68 # %rpmldflags   = %optldflags - %filterout_ld
69 #
70 # Regular expressions are supported, but to avoid some character be treated
71 # as regular expression it must be escaped twice.
72
73 %filter_out                                             \
74         for (i = 1; i in I; i++) {      A=0;    \
75                 for (f in F) {                          \
76                         if (I[i] ~ "^" F[f] "$") A=1;   \
77                 };                                                      \
78                 if (!A) printf(I[i] FS);        \
79         }
80
81 %rpmcflags %(awk 'BEGIN {
82         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
83         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
84         %{filter_out}
85 }')
86
87 %rpmcxxflags %(awk 'BEGIN {
88         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
90         %{filter_out}
91 }')
92
93 %rpmldflags %(awk 'BEGIN {
94         split("%{?optldflags}",I);
95         split("%{?filterout_ld}",F)
96         %{filter_out}
97 }')
98
99 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100 # but, don't use it, better use gcc as linker
101 %ld_rpmldflags %(awk 'BEGIN {
102         split("%{rpmldflags}",F);
103         for (f in F) {
104                 s = F[f];
105                 if (s ~ /^-Wl,/) {
106                         s = substr(s,5);
107                         gsub(/,/," ",s);
108                 };
109                 printf(s FS);
110         };
111 }')
112
113 #-----------------------------------------------------------------
114 %configure2_13 { \
115  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
118  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
119  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
120  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
121  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
122  %{?__cc:CC="%{__cc}" ; export CC ; } \
123  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
124  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
125         --host=%{_target_platform} \
126         --prefix=%{_prefix} \
127         --exec-prefix=%{_exec_prefix} \
128         --bindir=%{_bindir} \
129         --sbindir=%{_sbindir} \
130         --sysconfdir=%{_sysconfdir} \
131         --datadir=%{_datadir} \
132         --includedir=%{_includedir} \
133         --libdir=%{_libdir} \
134         --libexecdir=%{_libexecdir} \
135         --localstatedir=%{_localstatedir} \
136         --sharedstatedir=%{_sharedstatedir} \
137         --mandir=%{_mandir} \
138         --infodir=%{_infodir} \
139         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
140         %{dependencytracking} \
141 }
142
143 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144 %__cmake        /usr/bin/cmake
145 %cmake { \
146 CC="%{__cc}" \
147 CXX="%{__cxx}" \
148 CFLAGS="%{rpmcflags}" \
149 CXXFLAGS="%{rpmcxxflags}" \
150 %{__cmake} \
151 }
152
153 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
154 %__scons        /usr/bin/scons
155 %scons { \
156 %{__scons} \
157         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158         CFLAGS="${CFLAGS:-%rpmcflags}" \
159         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160         FFLAGS="${FFLAGS:-%rpmcflags}" \
161         CPPFLAGS="${CPPFLAGS:-}" \
162         %{?__cc:CC="%{__cc}"} \
163         %{?__cxx:CXX="%{__cxx}"} \
164         libsuffix=%{_lib} \
165         prefix=%{_prefix} \
166 }
167
168 # waf. see waf.spec
169 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
170 %__waf  /usr/bin/waf
171 %waf { \
172 CC="%{__cc}" \
173 CXX="%{__cxx}" \
174 CPP="%{__cpp}" \
175 CFLAGS="%{rpmcflags}" \
176 CXXFLAGS="%{rpmcxxflags}" \
177 %{__waf} \
178 }
179
180 #----------------------------------------------------------------
181 #%configure_cache 0
182 %configure_cache_file   %{buildroot}.configure.cache
183
184 %configure {./configure \
185         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186         CFLAGS="${CFLAGS:-%rpmcflags}" \
187         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
188         FFLAGS="${FFLAGS:-%rpmcflags}" \
189         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
190         CPPFLAGS="${CPPFLAGS:-}" \
191         %{?__cc:CC="%{__cc}"} \
192         %{?__cxx:CXX="%{__cxx}"} \
193         --host=%{_target_platform} \
194         --build=%{_target_platform} \
195         --prefix=%{_prefix} \
196         --exec-prefix=%{_exec_prefix} \
197         --bindir=%{_bindir} \
198         --sbindir=%{_sbindir} \
199         --sysconfdir=%{_sysconfdir} \
200         --datadir=%{_datadir} \
201         --includedir=%{_includedir} \
202         --libdir=%{_libdir} \
203         --libexecdir=%{_libexecdir} \
204         --localstatedir=%{_localstatedir} \
205         --sharedstatedir=%{_sharedstatedir} \
206         --mandir=%{_mandir} \
207         --infodir=%{_infodir} \
208         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
209         %{dependencytracking} \
210         %{?configure_cache:--cache-file=%{configure_cache_file}} \
211 }
212
213 # overload to insert debuginfo package
214 %prep \
215 %if 0%{?_enable_debug_packages}\
216 %{debug_package}\
217 %endif\
218 %%prep\
219 %{nil}
220
221 # Location of autoconf macros
222 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir)}%_aclocaldir
223
224 # Location of omf files
225 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir)}%_omf_dest_dir
226
227 # Location of pkgconfig files
228 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
229
230 # Location of desktop files
231 %_desktopdir    /usr/share/applications
232 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
233
234 # Location of pixmaps for applnk/desktop files
235 %_pixmapsdir    /usr/share/pixmaps
236
237 # Location of themable icons for applnk/desktop files
238 %_iconsdir      /usr/share/icons
239
240 # Location of fonts directories
241 %_fontsdir      /usr/share/fonts
242
243 # Location of Gtk and associated libraries documentation
244 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
245
246 # Location of KDE documentation
247 %_kdedocdir     %{_defaultdocdir}/kde/HTML
248
249 # unsermake script
250 %__unsermake /usr/share/unsermake/unsermake
251
252 # Current date
253 %date           %(LC_ALL="C" date +"%a %b %d %Y")
254
255 # tmp directory
256 %tmpdir         %{expand:%%global tmpdir %{lua:print(os.getenv("TMPDIR") or "/tmp")}}%{tmpdir}
257
258 # Example files, programs, scripts...
259 %_examplesdir   /usr/src/examples
260
261 # Alternative kernel type/version
262 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
263
264 # The directory holding Linux kernel sources
265 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
266
267 # If non-empty "debug" macro defined, add "dbg" suffix to release number
268 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
269
270 # Requires name = version-release
271 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
272
273 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
274 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
275 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
276 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
277 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
278 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
279
280 # XXX: why epoch 0 is stripped?
281 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
282 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
283
284 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
285
286 # kernel version-release handling
287 %__kernel_ver    %{expand:%%global __kernel_ver %%(VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))}%__kernel_ver
288 %__kernel_rel   %(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not")
289 %__kernel_rpmvr %(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not")
290 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
291 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
292
293 # sgml macros
294 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
295 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
296 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
297 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
298 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
299 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
300 %docbook_sgmlcat_fix() { for l in \
301 '' \
302 '  -- default decl --' \
303 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
304 '  -- hacks for opensp --' \
305 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
306 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
307 '' \
308 ; do echo $l; done >> %1 \
309 }
310
311 # vim - "
312
313 # minimum file size needed for compressed documents.
314 # just smaller files than this get larger when compressed.
315 # some stats:
316 # - 0 byte file compressed was 25 bytes .gz
317 # - 39 byte file was compressed as 57
318 # - with test/test.spec@man 158 byte file was compressed also 158
319 %_min_compress_bytes    159
320
321 #-----------------------------------------------------------------
322 # find and gzip all files in %{_mandir} and %{infodir}
323 #
324 # Requires: xargs, find
325 #
326 #%no_install_post_compress_docs 1
327 %__spec_install_post_compress_docs { \
328 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
329         for i in /usr/share/man /usr/X11R6/man; do \
330                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
331                         echo "Compress man pages: $i"; \
332                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
333                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
334                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
335                                 m=$(readlink $a); \
336                                 rm -f $a; \
337                                 echo .so ${m##*/} > $a; \
338                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
339                         done; \
340                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
341                 fi; \
342         done; \
343         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
344                 echo "Compress info pages: %{_infodir}"; \
345                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
346                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
347                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
348         fi; \
349 }; __spec_install_post_compress_docs } }
350
351 #-----------------------------------------------------------------
352 # Strip executable binaries and shared object files
353 #
354 # Requires: find, awk, strip, cut, xargs
355 #
356 # Special macros which affect this process:
357 #%no_install_post_strip 1               # disable stripping at all
358 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
359 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
360 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
361 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
362 #
363 %__spec_install_post_strip {%{!?debug: \
364 %{!?no_install_post_strip:__spec_install_post_strip() { \
365 if [ -d "$RPM_BUILD_ROOT" ]; then \
366         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
367                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
368                 if [ "$modulelist" ]; then \
369                         modulecount=$(echo "$modulelist" | wc -l); \
370                         printf "Stripping %d kernel modules..." $modulecount; \
371                         echo "$modulelist" | xargs -l512 chmod u+w; \
372                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
373                         echo "DONE"; \
374                 fi; \
375         fi; \
376         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
377         if [ -n "$filelist" ]; then \
378                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
379                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
380                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
381                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
382                 if [ -n "$elfexelist" ]; then \
383                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
384                         chmod u+w $elfexelist; \
385                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
386                         echo "DONE"; \
387                 fi; \
388                 if [ -n "$elfsharedlist" ]; then \
389                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
390                         chmod u+w $elfsharedlist; \
391                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
392                         echo "DONE"; \
393                 fi; \
394                 if [ -n "$archiveslist" ]; then \
395                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
396                         chmod u+w $archiveslist; \
397                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
398                         echo "DONE"; \
399                 fi; \
400         fi; \
401     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
402     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
403     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
404         if [ -n "$filelist_all" ]; then \
405                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
406                 chmod u+w $filelist_all; \
407                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
408                 echo "DONE"; \
409         fi; \
410         if [ -n "$filelist_unneeded" ]; then \
411                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
412                 chmod u+w $filelist_unneeded; \
413                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
414                 echo "DONE"; \
415         fi; \
416         if [ -n "$filelist_debug" ]; then \
417                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
418                 chmod u+w $filelist_debug; \
419                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
420                 echo "DONE"; \
421         fi; \
422 fi; }; __spec_install_post_strip } } }
423
424 #-----------------------------------------------------------------
425 # remove all RPATH from executable binaries and shared object files
426 #
427 # Requires: find, awk, cut, xargs, chrpath, uname
428 #
429 # Special macros which affect this process
430 #%no_install_post_chrpath       1       # disable chrpath at all
431 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
432 #
433 %__spec_install_post_chrpath {%{!?debug: \
434 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
435 if [ -d "$RPM_BUILD_ROOT" ]; then \
436         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
437         if [ -n "$files" ]; then \
438                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
439         fi; \
440         if [ -n "$objs" ]; then \
441                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
442                 echo "$objs" | \
443                 while read file; do \
444                         rpath= ; \
445                         chmod u+w "$file"; \
446                         for dir in `chrpath -l "$file" | \
447                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
448                                         case $dir in \
449                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
450                                                 echo "remove-rpath: $dir in $file"; \
451                                                 ;; \
452                                         * ) \
453                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
454                                                 else rpath="$rpath:$dir" ; fi ; \
455                                                 ;; \
456                                         esac ; \
457                         done ; \
458                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
459                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
460                 done; \
461         fi; \
462 fi; }; __spec_install_post_chrpath } } }
463
464 #-----------------------------------------------------------------
465 # Find and gzip all kernel modules
466 #
467 # Requires: find
468 #
469 #%no_install_post_compress_modules      1
470 %__spec_install_post_compress_modules { \
471 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
472         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
473                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
474                 if [ "$q" ]; then \
475                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
476                         echo "$q" | xargs -r %{__gzip} -9nf; \
477                         echo "DONE"; \
478                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
479                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
480                 fi; \
481         fi; \
482 }; __spec_install_post_compress_modules } }
483
484 # Remove common Perl files we don't package
485 %__spec_install_post_perl_clean {\
486 %{!?no_install_post_perl_clean: \
487 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
488 } }
489
490 #-----------------------------------------------------------------
491 # Update GConf2 schemas
492 #
493 # Requires: GConf2
494 #
495 %gconf_schema_install() \
496         umask 022; \
497         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
498 %{nil}
499
500 %gconf_schema_uninstall() \
501 if [ $1 = 0 ]; then \
502         umask 022; \
503         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
504 fi; \
505 %{nil}
506
507 #-----------------------------------------------------------------
508 # Update desktop MIME database
509 # requires: desktop-file-utils
510 #
511 %update_desktop_database_post() \
512         umask 022; \
513         /usr/bin/update-desktop-database -q; \
514 %{nil}
515
516 %update_desktop_database_postun() \
517 if [ "$1" = "0" ]; then \
518         umask 022; \
519         /usr/bin/update-desktop-database -q; \
520 fi; \
521 %{nil}
522
523 #-----------------------------------------------------------------
524 # Update shared MIME info database
525 # requires: shared-mime-info
526 #
527 %update_mime_database() \
528         umask 022; \
529         /usr/bin/update-mime-database %{_datadir}/mime; \
530 %{nil}
531
532 #-----------------------------------------------------------------
533 # Update icon cache
534 # requires: gtk+
535 #
536 %update_icon_cache() \
537         umask 022; \
538         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
539 %{nil}
540
541 #-----------------------------------------------------------------
542 # Update scrollkeeper database
543 # requires: scrollkeeper
544 #
545 %scrollkeeper_update_post() \
546         /usr/bin/scrollkeeper-update -q; \
547 %{nil}
548
549 %scrollkeeper_update_postun() \
550 if [ "$1" = "0" ]; then \
551         /usr/bin/scrollkeeper-update -q; \
552 fi; \
553 %{nil}
554
555 #-----------------------------------------------------------------
556 # post %install sequence:
557 # - autodeps exceptions
558 # - compress all man and info pages,
559 # - strip all ELF executables and ELF shared objects if not %debug.
560 # - compress kernel modules if any
561
562 ###################################################################
563 # Requires/Provides automation
564 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
565 #
566 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
567 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
568 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
569 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
570 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
571 #%_noautocompressdoc    %{nil}
572 #
573 %_missing_doc_files_terminate_build     1%{nil}
574 %_unpackaged_files_terminate_build      %{nil}
575 # (X)emacs support
576 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
577 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
578 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
579
580 %__php_provides %{nil}
581 %__php_requires %{nil}
582 %__perl_provides %{nil}
583 %__perl_requires %{nil}
584 %__mono_provides %{nil}
585 %__mono_requires %{nil}
586
587 # Perl specific macro definitions.
588 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
589 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
590 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
591 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
592 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
593 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
594
595 # Ruby
596 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
597 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
598 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
599 %ruby_vendorarchdir     %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
600 %ruby_vendorlibdir      %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
601 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
602 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
603 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
604 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
605 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
606
607 %php_pear_dir           /usr/share/pear
608 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
609 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
610 %php_includedir         %(php-config --include-dir 2>/dev/null || echo ERROR)
611
612 # extract php/zend api versions
613 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
614 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
615 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
616 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
617 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
618 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
619 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
620
621 # helper macro
622 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
623
624 # macros for public use
625 # for php extensions (php-pecl)
626 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
627 %{__php_api_requires zend_module_api} \
628 %{__php_api_requires -v %php_major_version debug php_debug} \
629 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
630
631 # for zend extensions
632 %requires_zend_extension %{__php_api_requires zend_module_api} \
633 %{__php_api_requires zend_extension_api} \
634 %{__php_api_requires -v %php_major_version debug php_debug} \
635 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
636
637 # for php pdo modules (php-pecl-PDO_*)
638 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
639
640 # for using PHP post scripts. for PHP >= 5.0
641 %php_webserver_restart \
642 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
643 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
644 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
645         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
646         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
647                 %service -q php-fcgi restart \
648         fi \
649 fi \
650 %{nil}
651
652 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
653 %php4_webserver_restart \
654 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
655 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
656 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
657         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
658         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
659                 %service -q php-fcgi restart \
660         fi \
661 fi \
662 %{nil}
663
664
665 # X.org helper macros
666 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
667 #
668 %xorg_xserver_ansic_abi         %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
669 %xorg_xserver_extension_abi     %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
670 %xorg_xserver_font_abi          %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
671 %xorg_xserver_videodrv_abi      %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
672 %xorg_xserver_xinput_abi        %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
673
674 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
675 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
676 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
677 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
678 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
679 %{__xorg_abi_requires font xorg_xserver_font_abi}
680 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
681 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
682
683 # Python specific macro definitions.
684 # python main version
685 %py_ver                 %(python -c "import sys; print sys.version[:3]")
686
687 # directories
688 %py_prefix              %(python -c "import sys; print sys.prefix")
689 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
690 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
691 %py_incdir              /usr/include/python%{py_ver}
692 %py_sitedir             %{py_libdir}/site-packages
693 %py_sitescriptdir %{py_scriptdir}/site-packages
694 %py_dyndir              %{py_libdir}/lib-dynload
695
696 # pure python modules compilation
697 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
698
699 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
700
701 # Software written in Python language require Python with main version
702 %pyrequires_eq() Requires:      %1
703
704 # Hardlink binary identical .pyc and .pyo files
705 # (idea by glen <at> pld-linux <dot> org)
706 %__spec_install_post_py_hardlink {\
707 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
708 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
709         b="${a%.pyc}.pyo"; \
710         if cmp -s "$a" "$b"; then \
711                 ln -f "$a" "$b"; \
712         fi; \
713 done \
714 }; __spec_install_post_py_hardlink } }
715
716 # remove python sources, so that check-files won't complain
717 # (idea by glen <at> pld-linux <dot> org)
718 %py_postclean() \
719 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
720  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
721 done \
722 %{nil}
723
724 # depmod macro
725 %depmod() { \
726 umask 022; \
727 if [ -e /boot/System.map-%1 ]; then \
728         /sbin/depmod -a -F /boot/System.map-%1 %1; \
729 else \
730         if [ -e /boot/System.map ]; then \
731                 /sbin/depmod -a -F /boot/System.map %1; \
732         else \
733                 /sbin/depmod -a %1; \
734         fi \
735 fi; \
736 }
737
738 # XMMS specific macros
739 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
740 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
741 %xmms_version                   %(xmms-config --version 2>/dev/null)
742 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
743 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
744 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
745 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
746 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
747 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
748 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
749
750 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
751
752 # user/group checking macros
753 #
754 # Usage:
755 #       %userremove myuser
756 #
757 %userremove     /usr/lib/rpm/user_group.sh user del
758 %groupremove    /usr/lib/rpm/user_group.sh group del
759 #
760 # Usage:
761 #       if %usertestrm myuser; then
762 #               /usr/sbin/userdel -r myuser
763 # Note:
764 #       use these macros only if you need to call userdel/groupdel with
765 #       a non-standard option or take an extra action; otherwise use the
766 #       %userremove/%groupremove macros
767 #
768 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
769 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
770 # user group membership management macros
771 #
772 # Usage:
773 #       %addusertogroup myuser agroup
774 #
775 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
776
777 # banner support (useful in {pre,post}{,un} and triggers)
778 #
779 # Usage:
780 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
781 # the banner text, the banner text
782 # the banner text, and following line
783 #EOF
784 # You can use any form of here-document, <<'EOF' <<-EOT will do.
785 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
786 #
787 # -a   - append to the banner
788 # -e   - send to stderr instead of stdout
789 # -n   - no show banner (overrides -t)
790 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
791 #
792 # Tests:
793 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
794 # rpm -E 'date | %banner -e banner' > m; sh -x m
795 #
796 %banner(aent:) ( \
797 RPM_SCRIPTVERBOSITY=5 \
798 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
799 if [ -x /usr/bin/banner.sh ]; then \
800         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
801 else \
802         CMD="cat%{-e: >&2}" \
803 fi \
804 eval $CMD %{?2:%2}%{?3: %3}) \
805 %{nil}
806
807 # useradd/groupadd macros
808 # Author: Elan Ruusamäe <glen@pld-linux.org>
809 #
810 # Usage:
811 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
812 #   [-g initial_group] [-G group[,...]] login
813 #
814 #  -u uid. REQUIRED
815 #  -g gid/group. REQUIRED
816 #  -s defaults to /bin/false
817 #  -d defaults to /usr/share/empty
818 #  -c No default
819 #  -r is accepted but ignored (it's always set)
820 #  -k skeleton dir. defaults to /usr/share/empty
821 # rpm specific flags
822 #  -P package name. defaults to %{name}
823 #
824 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
825 %{!-u:%{error:useradd: Required argument -u missing}} \
826 %{!-g:%{error:useradd: Required argument -g missing}} \
827 %{!?1:%{error:useradd: Required parameter login missing}} \
828 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
829         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
830                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
831                 exit 1 \
832         fi \
833 else \
834         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
835         /usr/sbin/useradd \\\
836                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
837                 -u %{-u*} \\\
838                 -r \\\
839                 -d %{-d*}%{!-d:/usr/share/empty} \\\
840                 -s %{-s*}%{!-s:/bin/false} \\\
841                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
842                 -g %{-g*} \\\
843                 %{-M} \\\
844                 %{-G:-G %{-G*}} \\\
845                 %{expand:%{%{#}}} 1>&2 || exit $? \
846         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
847 fi;
848
849 # Usage:
850 #   %groupadd [-P package] [-g gid] group
851 #
852 # -g gid. REQUIRED
853 #
854 # Sample:
855 #   %groupadd -P %{name}-base -g %{gid} %{name}
856
857 %groupadd(g:P:rfo)      \
858 %{!-g:%{error:groupadd: Required argument -g missing}} \
859 %{!?1:%{error:groupadd: Required parameter group missing}} \
860 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
861         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
862                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
863                 exit 1 \
864         fi \
865 else \
866         echo "Adding group %{1} GID=%{-g*}." \
867         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
868         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
869 fi;
870
871 # webapp macros
872 # Author: Elan Ruusamäe <glen@pld-linux.org>
873 #
874 # The config is installed/removed inside trigger, this means that you can any
875 # time install apache1/apache/lighttpd package and the configuration file is
876 # updated. if you don't need the config for various reason for specific
877 # webserver, just remove the symlink from config directory using webapp
878 # program. the trigger will not recreate the symlink on upgrades. In other
879 # words the config is linked to webserver config directory on first install of
880 # PACKAGE or WEBSERVER.
881 #
882 # Add package's webserver config to webserver webapps dir.
883 # Usage:
884 #   %webapp_register WEBSERVER WEBAPP
885 #
886 %webapp_register() \
887 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
888 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
889         /usr/sbin/webapp register %1 %2\
890 fi\
891 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
892 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
893         %{expand:%service -q %%1 reload}\
894 fi\
895 %{nil}
896
897 # Remove package's config from webserver webapps dir.
898 # Usage:
899 #   %webapp_register [-f] WEBSERVER WEBAPP
900 %webapp_unregister(f) \
901 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
902 # remove link if either of the packages are gone \
903 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
904         /usr/sbin/webapp unregister %1 %2\
905         %{expand:%service -q %%1 reload}\
906 fi \
907 %{nil}
908
909 # service macro.
910 # Author: Elan Ruusamäe <glen@pld-linux.org>
911 #
912 # calls usual service restart on package %post, but skips the restart if
913 # administrator has disabled automatic service restarts in either global
914 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
915 #
916 # Usage:
917 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
918 #
919 #  -q be silent when service isn't started (for scriplets restaring other package's services)
920 #
921 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
922
923
924 # Java macros. based on jpackage macros.java
925 #
926 # Root directory where all Java VMs/SDK/JREs are installed.
927 %_jvmdir                %{_libdir}/jvm
928
929 # Root directory where all Java VMs/SDK/JREs expose their jars
930 %_jvmjardir             %{_libdir}/jvm-exports
931
932 # Root directory for all Java VM/SDK/JRE's private things.
933 %_jvmprivdir    %{_libdir}/jvm-private
934
935 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
936 %_jvmlibdir             %{_libdir}/jvm
937
938 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
939 %_jvmdatadir    %{_datadir}/jvm
940
941 # Root directory for all configurations parts of Java VM/SDK/JRE's
942 %_jvmsysconfdir %{_sysconfdir}/jvm
943
944 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
945 %_jvmcommonlibdir       %{_libdir}/jvm-common
946
947 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
948 %_jvmcommondatadir      %{_datadir}/jvm-common
949
950 # Root directory for all common configurations parts of Java VM/SDK/JRE's
951 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
952
953 # Directory where arch-specific (JNI) version-independent jars are installed.
954 %_jnidir                %{_libdir}/java
955
956 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
957
958 %ant                    JAVA_HOME=%{java_home} ant
959 %jar                    %{java_home}/bin/jar
960 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
961 %javac                  %{java_home}/bin/javac
962 %javadoc                %{java_home}/bin/javadoc
963
964 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
965
966 %jpackage_script() \
967 install -d $RPM_BUILD_ROOT%{_bindir}\
968 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
969 #!/bin/sh\
970 #\
971 # %{name} script\
972 # JPackage Project <http://www.jpackage.org/>\
973 \
974 # Source functions library\
975 . %{_javadir}-utils/java-functions\
976 \
977 # Source system prefs\
978 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
979     . %{_sysconfdir}/java/%{name}.conf\
980 fi\
981 \
982 # Source user prefs\
983 if [ -f $HOME/.%{name}rc ]; then\
984     . $HOME/.%{name}rc\
985 fi\
986 \
987 # Configuration\
988 MAIN_CLASS=%1\
989 BASE_FLAGS=%2\
990 BASE_OPTIONS=%3\
991 BASE_JARS="%(echo %4 | tr ':' ' ')"\
992 \
993 # Set parameters\
994 set_jvm\
995 set_classpath $BASE_JARS\
996 set_flags $BASE_FLAGS\
997 set_options $BASE_OPTIONS\
998 \
999 # Let's start\
1000 run "$@"\
1001 EOF
1002
1003 # jpackage 1.7
1004 # Directory for maven depmaps
1005 #
1006 %_mavendepmapdir /etc/maven
1007 %_mavendepmapfragdir /etc/maven/fragments
1008
1009 #
1010 # add_to_depmap adds an entry to the depmap. The arguments are:
1011 #
1012 # %1 the original groupid
1013 # %2 the original artifact id
1014 # %3 the version
1015 # %4 the new groupid
1016 # %5 the new artifactid
1017 #
1018
1019 %add_to_maven_depmap() \
1020 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1021 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1022 <dependency>\
1023     <maven>\
1024         <groupId>%1</groupId>\
1025         <artifactId>%2</artifactId>\
1026         <version>%3</version>\
1027     </maven>\
1028     <jpp>\
1029         <groupId>%4</groupId>\
1030         <artifactId>%5</artifactId>\
1031         <version>%3</version>\
1032     </jpp>\
1033 </dependency>\
1034 \
1035 EOF\
1036 %{nil}
1037
1038 #==============================================================================
1039 #
1040 # update_maven_depmap updates the main maven depmap
1041 #
1042 %update_maven_depmap() \
1043 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1044 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1045 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1046 fi\
1047 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1048
1049
1050 # PEAR install macros
1051 # Author: Elan Ruusamäe <glen@pld-linux.org>
1052 #
1053 # Usage:
1054 #       %%pear_package_setup [-a #] [-n FMT]
1055 #
1056 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1057 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1058 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1059 #
1060 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1061 # destination hierarchy. you should copy the tree to buildroot after
1062 # patching/reorganizing with %%pear_package_install.
1063 #
1064 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1065 # line endings.
1066 #
1067 # the pear install process output is recorded to install.log, you should put it
1068 # to %%doc for later debug or just for information.
1069 #
1070 # additionally additional-packages.txt is produced if it was detected that the
1071 # package has optional dependencies. the file format is suitable of displaying
1072 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1073 # automatically added for this file.
1074
1075
1076 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1077 %__pear_install_log \
1078 tee install.log \
1079 # make post message of optional packages \
1080 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1081 if [ -s optional-packages.txt ]; then \
1082         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1083 else \
1084         rm -f optional-packages.txt \
1085 fi \
1086 %{nil}
1087
1088 # command invoking pear cli
1089 %__pear /usr/bin/pear
1090
1091 %pear_install(a:n:zD) \
1092 %__pear \\\
1093         -c pearrc \\\
1094         -d doc_dir=/docs \\\
1095         -d php_dir=%{php_pear_dir} \\\
1096         -d bin_dir=%{_bindir} \\\
1097         -d data_dir=%{php_pear_dir}/data \\\
1098         -d test_dir=%{php_pear_dir}/tests \\\
1099         install \\\
1100         --packagingroot=%{builddir} \\\
1101         --offline \\\
1102         --nodeps \\\
1103         %{-f:--force} \\\
1104         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1105 %{nil}
1106
1107 # The main macro.
1108 # using this macro will append optional-packages.txt to the nocompressdoc list
1109 # as it's displayed to user after package install. and adding additional gzip
1110 # dep is just waste ;)
1111 %pear_package_setup(a:n:zD) \
1112 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1113 %define builddir %{_builddir}/%{srcdir} \
1114 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1115 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1116 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1117 %pear_install \
1118 %{-z:cd ..} \
1119 cat %{-z:$_N/}.install.log | %__pear_install_log \
1120 \
1121 # undos sources \
1122 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1123 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1124 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1125 %{nil}
1126
1127 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1128 # Author: Elan Ruusamäe <glen@pld-linux.org>
1129 %pear_package_install() \
1130 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1131 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1132 # help the developer out a little: \
1133 if [ -f _noautoreq ]; then \
1134         echo "AutoReqdep detected:" \
1135         echo "_noautoreq $(cat _noautoreq)" \
1136 fi \
1137 %{nil}
1138
1139
1140 # Register OpenLDAP schema.
1141 # Author: Elan Ruusamäe <glen@pld-linux.org>
1142 #
1143 # Usage:
1144 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1145 #
1146 #  -d specify dependant schemas, separated by comma
1147 #
1148 %openldap_schema_register(d:) \
1149 for schema in %*; do \
1150         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1151                 %{__sed} -i -e " \
1152                         /^include.*local.schema/{ \
1153                                 iinclude\\t     $schema\
1154                         } \
1155                 " /etc/openldap/slapd.conf \
1156         fi \
1157 done \
1158 # enable dependant schemas \
1159 if [ "%{-d*}" ]; then \
1160         %{__sed} -i -e ' \
1161         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1162                 s/^#// \
1163         }' /etc/openldap/slapd.conf \
1164 fi \
1165 %{nil}
1166
1167 # Unregister OpenLDAP schema.
1168 # Author: Elan Ruusamäe <glen@pld-linux.org>
1169 #
1170 # Usage:
1171 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1172 #
1173 %openldap_schema_unregister() \
1174 for schema in %*; do \
1175         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1176                 %{__sed} -i -e " \
1177                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1178                 # for symmetry it would be nice if we disable enabled schemas in post, \
1179                 # but we really can not do that, it would break something else. \
1180                 " /etc/openldap/slapd.conf \
1181         fi \
1182 done \
1183 %{nil}
1184
1185 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1186
1187
1188 # Build modules for kernels 2.6
1189 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1190 #
1191 # Usage:
1192 #       %build_kernel_modules -m <modules> -C <directory>
1193 #
1194 #  remember that proper Makefile is still required
1195 # Options:
1196 #  -m <modules> (required) -- comma-separated list of modules to save,
1197 #               without .ko extension, may be placed in subdirectory
1198 #  -C <directory> -- change to <directory> before doing anything
1199 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1200 #  -c -- do not execute make clean
1201 #  <additional arguments> -- all additional arguments will be passed to
1202 #               make modules
1203 #
1204 # Additional patching supported via here document. Try:
1205 #       %build_kernel_modules -m module <<'EOF'
1206 #       your patch script here
1207 #       EOF
1208 # Don't use it unless patching depends on config options.
1209
1210 # Developer note: don't touch it unless you know how to handle '\'.
1211 # - \ in script expands to nothing
1212 # - \\\ in script expands to \
1213 # - \\\ inside definition expands to nothing
1214 # - \\\\\\\ inside definition expands to \
1215 # - in last line \ has to touch arguments so arguments passing
1216 #   in new lines (using \) will be supported
1217
1218 %build_kernel_modules(p:P:m:C:c)                                                                        \
1219 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1220                                                                                                                                         \
1221 %define Opts                                                                                                            \\\\\\\
1222 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1223         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1224         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1225         %else                                                                                                                   \\\
1226         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1227         %endif                                                                                                                  \\\
1228 %else                                                                                                                           \\\
1229         CC="%{kgcc}"                                                                                                    \\\
1230 %endif                                                                                                                          \
1231 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1232                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1233                                                                                                                                         \
1234 %{?-C:cd %{-C*}}                                                                                                        \
1235 compile() {                                                                                                                     \
1236         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1237         set -e -x                                                                                                               \
1238         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1239                                                                                                                                         \
1240 for cfg in ${cfgs:-dist}; do                                        \
1241         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1242                                                                                                                                         \
1243         rm -rf o                                                                                                                \
1244         install -d o/include/linux                                                                              \
1245         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1246         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1247         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1248                                                                                                                                         \
1249         set +x                                                                                                                  \
1250         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1251         set -x                                                                                                                  \
1252                                                                                                                                         \
1253         %if %{with dist_kernel}                                                                                 \
1254                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1255                         %{-p*} %{-P*}                                                                                   \\\
1256                         %{MakeOpts}                                                                                             \
1257         %else                                                                                                                   \
1258                 install -d o/include/config                                                                     \
1259                 touch o/include/config/MARKER                                                           \
1260                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1261         %endif                                                                                                                  \
1262                                                                                                                                         \
1263         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1264                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1265                 ${1+"$@"}                                                                                                       \\\
1266                 M=$PWD %{MakeOpts}}                                                                                     \
1267                                                                                                                                         \
1268         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1269                 ${1+"$@"}                                                                                                       \\\
1270                 M=$PWD %{MakeOpts}                                                                                      \
1271                                                                                                                                         \
1272         for MODULE in {%{-m*},}; do                                                                             \
1273                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1274         done                                                                                                                    \
1275 done                                                                                                                            \
1276 %{?-C:cd -}                                                                                                                     \
1277 }                                                                                                                                       \
1278 compile %{*}\
1279 %{nil}
1280
1281
1282 # Install kernel modules built by %build_kernel_modules
1283 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1284 #
1285 # Usage:
1286 #       %install_kernel_modules -m <modules> -d <directory>
1287 #
1288 # Options:
1289 #  -m <modules> (required) -- comma-separated list of modules to install,
1290 #               without .ko extension, may be placed in subdirectory
1291 #  -d <directory> (required) -- in what subdirectory modules should be
1292 #               installed (eg. misc, kernel/drivers/net)
1293 #  -s <suffix> -- suffix to use when installing modules, useful when module
1294 #               with same name exists in kernel already
1295 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1296 #               for defining aliases, only useful with -s
1297
1298 %install_kernel_modules(m:d:s:n:)                                                                       \
1299 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1300 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1301 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1302                                                                                                                                         \
1303 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1304 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1305                                                                                                                                         \
1306 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1307                                                                                                                                         \
1308 for MODULE in {%{-m*},}; do                                                                                     \
1309         [ -n "${MODULE}" ] || continue                                                                  \
1310         for cfg in ${cfgs:-dist}; do                                    \
1311                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1312                 MNAME=${MODULE##*/}                                                                                     \
1313                 install -D ${MODULE}-$cfg.ko                                                            \\\
1314                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1315                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1316                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1317                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1318         done                                                                                                                    \
1319 done                                                                                                                            \
1320 %{nil}
1321
1322 # patchset macros
1323 # Author: Elan Ruusamäe <glen@pld-linux.org>
1324 #
1325 # Usage:
1326 #   %patchset_source -f <seq(1) format> <start> [<end>]
1327 #   %patchset_patch <start> [<end>]
1328 #
1329 # If <end> is omited, it is assumed to be <start>.
1330 #
1331 # For example in preamble:
1332 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1333 # and in %prep:
1334 #  %patchset_patch 33 44
1335
1336 # generate SourceX urls from range START STOP
1337 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1338 # The sources start from 10000
1339 %patchset_source(f:b:) %(
1340         base=%{-b*}%{!-b*:10000};
1341         start=$(expr $base + %1);
1342         end=$(expr $base + %{?2}%{!?2:%{1}});
1343         # we need to call seq twice as it doesn't allow two formats
1344         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1345         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1346         paste %{tmpdir}/__ps{1,2};
1347         rm -f %{tmpdir}/__ps{1,2};
1348 ) \
1349 %{nil}
1350
1351 # apply sources from %patchset_source
1352 # -p specify -pX for %patch line
1353 # -b base offset: defaults to 10000
1354 %patchset_patch(f:p:b:) %(
1355         base=%{-b*}%{!-b*:10000};
1356         start=$(expr $base + %1);
1357         end=$(expr $base + %{?2}%{!?2:%{1}});
1358         echo ": patchset_patch %1%{?2: to %2}";
1359         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1360 ) \
1361 %{nil}
1362
1363 # browser plugins v2
1364 # Author: Elan Ruusamäe <glen@pld-linux.org>
1365 #
1366 # Usage:
1367 #       %browser_plugins_add_browser <name> -p <plugindir>
1368 #
1369 #  <name> (required) -- name of the browser. usually %{name}.
1370 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1371 #  -b -- default blacklists
1372 #  -a <arch> override arch
1373 #
1374 # Example:
1375 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1376
1377 %_browserpluginsconfdir         /etc/browser-plugins
1378 %_browserpluginsdir                     %{_libdir}/browser-plugins
1379 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1380
1381 %browser_plugins_add_browser(p:b:a:) \
1382         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1383         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1384         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1385         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1386         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1387         %{-b:cat >> $blacklist_file %{-b*}} \
1388 %{nil}
1389
1390 # Helper for LUA.
1391 # split string separated by space into quoted list
1392 #
1393 # Author: Elan Ruusamäe <glen@pld-linux.org>
1394 #
1395 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1396 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1397
1398 # adjust /etc/shells by adding and removing shells from there
1399 # Author: Elan Ruusamäe <glen@pld-linux.org>
1400 #
1401 # Usage:
1402 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1403 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1404 #
1405 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1406
1407 %add_etc_shells(p) %{-p:<lua>}\
1408 t = {}\
1409 f = io.open("/etc/shells", "r")\
1410 if f then\
1411         for l in f:lines() do t[l]=l; end\
1412         f:close()\
1413 end\
1414 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1415         if not t[s] then\
1416                 print("Adding "..s.." to /etc/shells")\
1417                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1418         end\
1419 end\
1420 %{nil}
1421
1422 %remove_etc_shells(p) %{-p:<lua>}\
1423 %{-p:if arg[2] == 0 then}\
1424         t = {}\
1425         f = io.open("/etc/shells", "r")\
1426         if f then\
1427                 for l in f:lines() do t[l]=l; end\
1428                 f:close()\
1429         end\
1430         for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1431                 print("Removing "..l.." from /etc/shells")\
1432                 t[l] = nil\
1433         end\
1434         s=""\
1435         for _, l in pairs(t) do\
1436                 s=s..l.."\\n"\
1437         end\
1438         io.open("/etc/shells", "w"):write(s)\
1439 %{-p:end} \
1440 %{nil}
1441
1442 # vim:ts=4 sw=4 noet syn=spec
This page took 0.278767 seconds and 4 git commands to generate.